import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class worldOne here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */

public class worldOne extends World
{
    public static int step = 5;
    int peasantNumber = Greenfoot.getRandomNumber(5);
    int x = Greenfoot.getRandomNumber(1000);
    int y = Greenfoot.getRandomNumber(550);
    //scrolling ints and GI's
    private static final GreenfootImage bgImage = new GreenfootImage("Dragon World.png");
    private GreenfootImage scrollingPic;
    private int scrollPositionX = 0;

    public void reroll()
    {
        x = Greenfoot.getRandomNumber(1000);
        y = Greenfoot.getRandomNumber(550);
    }

    public worldOne()
    {
        super(1000, 550, 1, false);

        GreenfootImage background = new GreenfootImage(1000, 550);
        scrollingPic = getScrollingImage(1000, 550);
        background.drawImage(scrollingPic, 0, 0);
        setBackground(background);

        worldDragon.sizex = 71;
        worldDragon.sizey = 50;
        worldDragon.speed = 4;

        addObject (new worldDragon(), 50, 500);
        addObject (new HPBar(), 120, 16);
        addObject (new MPBar(), 120, 56);
        addObject (new limBar(), 120, 106);
        addObject (new foodList(), 300, 60);
        addObject (new Harpy(), x, y);
        reroll();
        addObject (new Spider(), x, y);
        reroll();
        while (peasantNumber > 0)
        {
            addObject (new Peasant(), x, y);
            reroll();
            peasantNumber--;
        }
    }

    public void act()
    {
        //sets the "AI" of an enemy
        if (step == 5)
        {
            step = 0;
        }
        step++;
        //initiates the fight seq.
        if (Arena.enemyType != 0) 
        {  
            Greenfoot.setWorld(new Arena());  
        }
        //now the scrolling stuff
        if(worldDragon.speed > 0 && scrollPositionX <= 0) 
        {
            scrollPositionX = getWidth();
        }

        if(worldDragon.speed < 0 && scrollPositionX >= getWidth())
        {
            scrollPositionX = 0;
        }
        scrollPositionX -= worldDragon.speed;
        //Harpy's AI
        if (Harpy.rx < 270)
        {
            Harpy.direction = 2;
        }

        if (Harpy.rx > 1000)
        {
            Harpy.direction = 6;
        }

        if (Harpy.ry < 0)
        {
            Harpy.direction = 4;
        }

        if (Harpy.ry > 550)
        {
            Harpy.direction = 0;
        }
        //Spider's AI
        if (Spider.rx < 270)
        {
            Spider.direction = 2;
        }

        if (Spider.rx > 1000)
        {
            Spider.direction = 6;
        }

        if (Spider.ry < 0)
        {
            Spider.direction = 4;
        }

        if (Spider.ry > 550)
        {
            Spider.direction = 0;
        }

        if (step == 65)
        {
            step = 0;
        }
        //Peasant's AI
        if (Peasant.rx < 270)
        {
            Peasant.direction = 2;
        }

        if (Peasant.rx > 1000)
        {
            Peasant.direction = 6;
        }

        if (Peasant.ry < 0)
        {
            Peasant.direction = 4;
        }

        if (Peasant.ry > 550)
        {
            Peasant.direction = 0;
        }
    }

    private void paint(int position)
    {
        GreenfootImage bg = getBackground();
        bg.drawImage(scrollingPic, position, 0);
        bg.drawImage(scrollingPic, position - scrollingPic.getWidth(), 0);
    }

    private GreenfootImage getScrollingImage(int width, int height)
    {
        GreenfootImage image = new GreenfootImage(width, height);
        for(int x = 0; x < width; x += bgImage.getWidth()) {
            for(int y = 0; y < height; y += bgImage.getHeight()) {
                image.drawImage(bgImage, x, y);
            }
        }
        return image;
    }
}