import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;


public class Player  extends Actor
{
    private Level l;

    public Player() {
        GreenfootImage image = new GreenfootImage(20,20);
        image.setColor(Color.WHITE);
        image.fillOval(0,0,20,20);
        setImage(image);
    }
        
    public void addedToWorld(World world) {
        l = (Level) world;
    }
        
    public void act() 
    {
        checkKeys();
    }
    
    public void checkKeys() {
        if(Greenfoot.isKeyDown("up")) {
            Block b = null;
            for(int i = 0; i < 2; i++) {
                b = (Block) getOneObjectAtOffset(0, -11 - i*2, Block.class);
                if(b != null) {
                    break;
                }
            }
            if(b == null) {
                l.moveScreen(l.UP);
            }
        }
        if(Greenfoot.isKeyDown("right")) {
            Block b = null;
            for(int i = 0; i < 2; i++) {
                b = (Block) getOneObjectAtOffset(11 + i*2, 0, Block.class);
                if(b != null) {
                    break;
                }
            }
            if(b == null) {
                l.moveScreen(l.RIGHT);
            }
        }
        if(Greenfoot.isKeyDown("down")) {
            Block b = null;
            for(int i = 0; i < 2; i++) {
                b = (Block) getOneObjectAtOffset(0, +11 + i*2, Block.class);
                if(b != null) {
                    break;
                }
            }
            if(b == null) {
                l.moveScreen(l.DOWN);
            }
        }
        if(Greenfoot.isKeyDown("left")) {
            Block b = null;
            for(int i = 0; i < 2; i++) {
                b = (Block) getOneObjectAtOffset(-11 - i*2, 0, Block.class);
                if(b != null) {
                    break;
                }
            }
            if(b == null) {
                l.moveScreen(l.LEFT);
            }
        }
    }
}
